require 'json'

module ExoLogging
  class IntegrationFailure
    include Mongoid::Document
    include Mongoid::Timestamps

    field :name,           type: String
    field :integration_id, type: String
    field :url,            type: String
    index({ url: 1 }, {})

    validates_length_of :url, minimum: 1

    @@app_name = 'Untitled'

    def self.set_app_name(appname)
      @@app_name = appname
    end

    def self.mk!(integration_id, url)
      x = IntegrationFailure.new
      x.name           = @@app_name
      x.integration_id = integration_id
      x.url            = url

      x.save!
      x
    end

    def self.mtbf(url, from=0, mtbf_type='decaying')
      from_time = ExoBasic::Timer.from_epoch(from).to_datetime
      failed_ts = IntegrationFailure.where(name: @@app_name,
                                           url: url,
                                           :created_at.gte => from_time)
                                    .map { |i| ExoBasic::Timer.to_epoch(i.created_at) }
                                    .to_a
                                    .sort

      ProviderFailure.mtbf_helper(failed_ts, mtbf_type)
    end

  end
end
