module ExoLogging
  class IntegrationRequest
    include Mongoid::Document
    include Mongoid::Timestamps

    field :name,           type: String
    field :integration_id, type: String
    field :cost,           type: Float

    validates_presence_of :cost

    @@app_name = 'Untitled'

    def self.set_app_name(appname)
      @@app_name = appname
    end

    def self.between(from, to)
      IntegrationRequest.where(name: @@app_name,
                               :created_at.gte => from,
                               :created_at.lte => to)
    end

    def self.mk!(integration_id, cost)
      x = IntegrationRequest.new
      x.name           = @@app_name
      x.integration_id = integration_id
      x.cost           = cost.to_f

      x.save!
      x
    end

  end
end
