module ExoLogging
  class ProviderRequest
    include Mongoid::Document
    include Mongoid::Timestamps

    field :name,     type: String
    field :provider, type: String
    field :cost,     type: Float

    validates_presence_of :cost
    validates_length_of :provider, minimum: 1

    @@app_name = 'Untitled'

    def self.set_app_name(appname)
      @@app_name = appname
    end

    def self.between(from, to)
      ProviderRequest.where(name: @@app_name,
                            :created_at.gte => from,
                            :created_at.lte => to)
    end

    def self.mk!(provider, cost)
      x = ProviderRequest.new
      x.name     = @@app_name
      x.provider = provider
      x.cost     = cost.to_f

      x.save!
      x
    end

  end
end
